
// FactoryAssistToolDlg.cpp : 实现文件
//

#include "stdafx.h"
#include "FactoryAssistTool.h"
#include "FactoryAssistToolDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// 对话框数据
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFactoryAssistToolDlg 对话框




CFactoryAssistToolDlg::CFactoryAssistToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFactoryAssistToolDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFactoryAssistToolDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, COMBO_FACTORY, m_cbFactory);
}

BEGIN_MESSAGE_MAP(CFactoryAssistToolDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(CHECK_ENABLE, &CFactoryAssistToolDlg::OnBnClickedEnable)
    ON_BN_CLICKED(BTN_SET_VIR_MAC, &CFactoryAssistToolDlg::OnBnClickedSetVirMac)
    ON_BN_CLICKED(CHECK_SNLIMIT, &CFactoryAssistToolDlg::OnBnClickedCheck2)
    ON_CBN_SELCHANGE(COMBO_FACTORY, &CFactoryAssistToolDlg::OnCbnSelchangeFactory)
END_MESSAGE_MAP()


// CFactoryAssistToolDlg 消息处理程序

BOOL CFactoryAssistToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码

    _MacFactoryName.insert(std::pair<CString, CString>(_T("惠州工厂"), _T("B0-00-00-00-00-0B")));
    _MacFactoryName.insert(std::pair<CString, CString>(_T("三华工厂"), _T("A0-00-00-00-00-0A")));
    _MacFactoryName.insert(std::pair<CString, CString>(_T("泰霖工厂"), _T("C0-00-00-00-00-0C")));

    TCHAR szValue[MAX_PATH] = {0};
    ::GetProfileString(_T("MOKAFactoryTools"), _T("TestMode"), _T("0"), szValue, MAX_PATH);
    ((CButton*)GetDlgItem(CHECK_ENABLE))->SetCheck(!_tcsicmp(szValue, _T("1")));

    memset(szValue, 0, MAX_PATH*sizeof(TCHAR));
    ::GetProfileString(_T("MOKAFactoryTools"), _T("OrderType"), _T(""), szValue, MAX_PATH);
    ((CButton*)GetDlgItem(CHECK_SNLIMIT))->SetCheck(!_tcsicmp(szValue, _T("TR")));

    memset(szValue, 0, MAX_PATH*sizeof(TCHAR));
    ::GetProfileString(_T("MOKAFactoryTools"), _T("VirMAC"), _T("B0-00-00-00-00-0B"), szValue, MAX_PATH);
    std::map<CString, CString>::iterator it = _MacFactoryName.begin();
    for ( ; it != _MacFactoryName.end(); it++)
    {
        if ( it->second.CompareNoCase(szValue) == 0 )
        {
            m_cbFactory.SelectString(0, it->first);
        }
    }

	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CFactoryAssistToolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CFactoryAssistToolDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CFactoryAssistToolDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CFactoryAssistToolDlg::OnBnClickedEnable()
{
    // TODO: 在此添加控件通知处理程序代码
    //::GetProfileString(_T("MOKAFactoryTools"), _T("TestMode"), _T("0"), szValue, MAX_PATH);
    BOOL bCheck = ((CButton*)GetDlgItem(CHECK_ENABLE))->GetCheck();
    WriteProfileString(_T("MOKAFactoryTools"), _T("TestMode"), bCheck ? _T("1") : _T("0"));
}

void CFactoryAssistToolDlg::OnBnClickedSetVirMac()
{
    // TODO: 在此添加控件通知处理程序代码
    int nCurSel = m_cbFactory.GetCurSel();
    if ( nCurSel != CB_ERR )
    {
        CString strText;
        m_cbFactory.GetLBText(nCurSel, strText);
        std::map<CString, CString>::iterator it = _MacFactoryName.find(strText);
        if ( it != _MacFactoryName.end() )
        {
            if(WriteProfileString(_T("MOKAFactoryTools"), _T("VirMAC"), it->second))
            {
                MessageBox(_T("修正成功"), _T("提示"), MB_OK);
            }
            else
            {
                CString strError;
                strError.Format(_T("修改失败：%ld"), GetLastError());
                MessageBox(strError, _T("提示"), MB_OK);
            }
        }
    }
}

void CFactoryAssistToolDlg::OnBnClickedCheck2()
{
    // TODO: 在此添加控件通知处理程序代码
    BOOL bCheck = !((CButton*)GetDlgItem(CHECK_SNLIMIT))->GetCheck();
    WriteProfileString(_T("MOKAFactoryTools"), _T("OrderType"), bCheck ? _T("") : _T("TR"));
}

void CFactoryAssistToolDlg::OnCbnSelchangeFactory()
{
    // TODO: 在此添加控件通知处理程序代码
    CString strFactory;
    int nCurSel = m_cbFactory.GetCurSel();
    if (nCurSel != CB_ERR)
    {
        CString strText;
        m_cbFactory.GetLBText(nCurSel, strText);
        std::map<CString, CString>::iterator it = _MacFactoryName.find(strText);
        if ( it != _MacFactoryName.end() )
        {
            if(WriteProfileString(_T("MOKAFactoryTools"), _T("VirMAC"), it->second))
            {
                MessageBox(_T("修正成功"), _T("提示"), MB_OK);
            }
            else
            {
                CString strError;
                strError.Format(_T("修改失败：%ld"), GetLastError());
                MessageBox(strError, _T("提示"), MB_OK);
            }
        }
    }
}
